/*
 * 18. Chapter: LED Chaser
 */
#include "../Headers/main.h"


int main(void)
{
    /* Buffer variable for the received data */
	char buffer;

    /* Initialization of inputs and outputs */
    IOInit();
	
	/* Set valid initial value for PORTB */
	PORTB = 0x01;
	
    /* Initialization of UART, 103 = 4800 baud, see page 165 of ATmega16A datasheet */
    UARTInit(103);
	
	FILE uart_output = FDEV_SETUP_STREAM(UARTPutchar,	NULL,			_FDEV_SETUP_WRITE);
	FILE uart_input  = FDEV_SETUP_STREAM(NULL,			UARTGetchar,	_FDEV_SETUP_READ);
	stdout = &uart_output;
	stdin  = &uart_input;
	
    /* Testing */
    puts("****UART initialized.****");
	
    /* Infinite loop */
    while (1)
    {
        /* I put the received data into the buffer */
        buffer = getchar();

		/* Processing the received data with switch-case structure:
		 * The structure allows the variable to be examined with a listof data.
		 * Each data value corresponds to one case.
		 */
		switch(buffer)
		{
			case LED_CODE:
			{
				puts("Led tipping has been received");
				PORTA = ~PORTA;
				break;
			}
			case LEFT:
			{
				puts("Running light to the left command has been received");
				RunningLightLeft();
				break;
			}
			case RIGHT:
			{
				puts("Running light to the right command has been received");
				RunningLightRight();
				break;
			}
			default:
			{
				printf("Unknown command: %c \n", buffer );
				break;
			}
		}
    }

    return 0;
}